//#############################
//# TESTPROGRAMM fr COACH2.2 #
//#############################
//Vor dem Start serielle Verbindung herstellen und 
//ein Hyperterminal mit 115200Baud, 8 Datenbits und einem Stop-Bit ffnen.
//Das Programm auf dem Vehikel kommuniziert mit dem Benutzer ber das Hyperterminal.

//Hier wird der Antrieb getestet.
//Folgen Sie den Anweisungen am Hyperterminal.


#include <avr/io.h>
#include <avr/interrupt.h>

#include "CoachBASIS.h"
#include "Coach.h"

#include "AnzeigeBASIS.h"
#include "Anzeige.h"

#include "TasterBASIS.h"
#include "Taster.h"

#include "RS232BASIS.h"
#include "RS232.h"

#include "MotorServoBASIS.h"
#include "MotorServo.h"

#include "DrehgeberBASIS.h"
#include "Drehgeber.h"

#include "ZyklusBASIS.h"
#include "Zyklus.h"

#include "SensorBASIS.h"
#include "Sensor.h"

#include "FunkBASIS.h"
#include "Funk.h"

Coach        coach;
Anzeige      anzeige;
Taster       taster;
RS232        rs232;
MotorServo   motorservo;
Drehgeber    drehgeber;
//Zyklus       zyklus;
Sensor       sensor;
Funk         funk;

int main(void)
{
    coach.start();
    anzeige.start();
    taster.start();
    rs232.start();
    motorservo.start();
    drehgeber.start();
    //zyklus.start();
    //sensor.start();

    //funk.start();     // Initialisiere das Funkmodul mit den Einstellungen fr COACH

	TCCR0 = (0<<FOC0) | (0<<WGM00) | (0<<COM01) | (0<<COM00) | (0<<WGM01) | (1<<CS02) | (0<<CS01) | (1<<CS00);

	int wertS=0;
	int wertT=0;
//	int dummy=0;
//	DDRB|=(1<<PB0);

    rs232.sendeText("\n\rHallo.\n\r");
//	PORTB&=0b11111110;

	while(!taster.gedrueckt());
	motorservo.geschwindigkeit(1023);
	TCNT0=0;
		
    while(true)
	{
		wertS=drehgeber.holeOmegaViertel();
		wertT=TCNT0;
		TCNT0=0;
/*		if (dummy==0){
			PORTB|=0b00000001;
			dummy=1;
		}
		else{
			PORTB&=0b11111110;
			dummy=0;
		}*/
		rs232.sendeInteger(wertT);
		rs232.sendeText(" ");
		rs232.sendeInteger(wertS);
		rs232.sendeText("\n");
	}

    //sensor.stop();
    //zyklus.stop();
    drehgeber.stop();
    motorservo.stop();
    rs232.stop();
    taster.stop();
    anzeige.stop();
    coach.stop();

	return 0;
}
