//#############################
//# TESTPROGRAMM fr COACH2.2 #
//#############################
//Vor dem Start serielle Verbindung herstellen und 
//ein Hyperterminal mit 115200Baud, 8 Datenbits und einem Stop-Bit ffnen.
//Das Programm auf dem Vehikel kommuniziert mit dem Benutzer ber das Hyperterminal.

//Hier wird der Antrieb getestet.
//Folgen Sie den Anweisungen am Hyperterminal.


#include <avr/io.h>
#include <avr/interrupt.h>

#include "CoachBASIS.h"
#include "Coach.h"

#include "AnzeigeBASIS.h"
#include "Anzeige.h"

#include "TasterBASIS.h"
#include "Taster.h"

#include "RS232BASIS.h"
#include "RS232.h"

#include "MotorServoBASIS.h"
#include "MotorServo.h"

#include "DrehgeberBASIS.h"
#include "Drehgeber.h"

#include "ZyklusBASIS.h"
#include "Zyklus.h"

#include "SensorBASIS.h"
#include "Sensor.h"

#include "FunkBASIS.h"
#include "Funk.h"

//die Parameter aus dem Optimierungsverfahren
//#define totzeit 0.015
//#define P 150
//#define D (5.5 / totzeit)
//#define I (80 * totzeit)

//per Hand gefundene Parameter
#define P 70
#define D 30
#define I 10

int e_alt;
double e_int;

int regler(int ist,int soll)
{
	int e=soll-ist;

	double PAnteil=P * e;
	double DAnteil=D *(e-e_alt);
	double IAnteil=I * e_int;

	e_alt =e;
	e_int+=e;

	if (e_int> 10000) e_int= 10000;
	if (e_int<-10000) e_int=-10000;

	int sum=(int)(PAnteil+DAnteil+IAnteil);
	if (sum> 1023) sum= 1023;
	if (sum<-1023) sum=-1023;
	return sum;
}

Coach        coach;
Anzeige      anzeige;
Taster       taster;
RS232        rs232;
MotorServo   motorservo;
Drehgeber    drehgeber;
Zyklus       zyklus;
Sensor       sensor;
Funk         funk;

int main(void)
{
    coach.start();
    anzeige.start();
    taster.start();
    rs232.start();
    motorservo.start();
    drehgeber.start();
    zyklus.start();
    //sensor.start();

    //funk.start();     // Initialisiere das Funkmodul mit den Einstellungen fr COACH

	//TCCR0 = (0<<FOC0) | (0<<WGM00) | (0<<COM01) | (0<<COM00) | (0<<WGM01) | (1<<CS02) | (0<<CS01) | (1<<CS00);

	int wertS=0;
	int wertT=0;
	e_alt=0;
	e_int=0;

    rs232.sendeText("\n\rHallo. Ich sende delta_t --- Omega_1/4_Ist --- Regel_PWM\n\r");

	while(!taster.gedrueckt());
	motorservo.richtung(0);
	TCNT0=0;
	zyklus.setzeMaxZaehler(50);
		
    while(true)
	{
		wertS=drehgeber.holeOmegaViertel();		//aktuelle Geschwindigkeit holen
		zyklus.warteBis_ms(15);					//Totzeit
		int regl=regler(wertS,15);				//regeln...
		motorservo.geschwindigkeit(regl);		//...und Wert einstellen
		wertT=TCNT0;							//Zeit auslesen...
		TCNT0=0;

		anzeige.zahl(wertS);
		rs232.sendeInteger(wertT);
		rs232.sendeText(" --- ");
		rs232.sendeInteger(wertS);
		rs232.sendeText(" --- ");
		rs232.sendeInteger(regl);
		rs232.sendeText("\n\r");
	}

    //sensor.stop();
    zyklus.stop();
    drehgeber.stop();
    motorservo.stop();
    rs232.stop();
    taster.stop();
    anzeige.stop();
    coach.stop();

	return 0;
}
